{ From : Andrey Tretjakov 2:5085/40  20.08.97 }
unit qcfg;

interface

type
    cfgItemType = (cfgFunc, cfgText, cfgInt, cfgChar, cfgLogic, cfgTrigger);
    cfgProc = procedure(text:string);

    cfgItem = record
        itemKeyword : string;
        itemType    : cfgItemType;
        itemFunc    : cfgProc;
        itemPtr     : pointer;
    end;

    PCfgParser = ^TCfgParser;
    TCfgParser = object
        filename        : string;
        table           : array [1..100] of cfgItem;
        count           : integer;
        invalidHandler  : cfgProc;
        constructor init(f:string);
        destructor  done;
        procedure addFunc(keyword:string; proc:cfgProc);
        procedure addString(keyword:string; strPtr:pointer);
        procedure addInteger(keyword:string; intPtr:pointer);
        procedure addLogic(keyword:string; boolPtr:pointer);
        procedure parse;
{        procedure parseLine(keyword:string; line4parse:string);}
    end;

implementation
uses qstr;

constructor TCfgParser.init(f:string);
begin
    filename:=f;
    count:=1;
    invalidHandler:=nil;
end;

destructor TCfgParser.done;
begin
    count:=1;
end;

procedure TCfgParser.addFunc(keyword:string; proc:cfgProc);
begin
    table[count].itemKeyword:=keyword;
    table[count].itemType:=cfgFunc;
    table[count].itemFunc:=proc;
    table[count].itemPtr:=nil;
    count:=count+1;
end;

procedure TCfgParser.addString(keyword:string; strPtr:pointer);
begin
    table[count].itemKeyword:=keyword;
    table[count].itemType:=cfgText;
    table[count].itemFunc:=nil;
    table[count].itemPtr:=strPtr;
    count:=count+1;
end;

procedure TCfgParser.addInteger(keyword:string; intPtr:pointer);
begin
    table[count].itemKeyword:=keyword;
    table[count].itemType:=cfgInt;
    table[count].itemFunc:=nil;
    table[count].itemPtr:=intPtr;
    count:=count+1;
end;

procedure TCfgParser.addLogic(keyword:string; boolPtr:pointer);
begin
    table[count].itemKeyword:=keyword;
    table[count].itemType:=cfgLogic;
    table[count].itemFunc:=nil;
    table[count].itemPtr:=boolPtr;
    count:=count+1;
end;

procedure TCfgParser.parse;
var stream      : text;
    line        : string;
    lineCount   : integer;
    pos         : integer;
    key         : string;
    line4parse  : string;
    haveArg     : Boolean;
    i           : integer;
    int,code    : integer;
begin
    Assign(stream,filename);
    Reset(stream);
    while not Eof(stream) do
    begin
        readln(stream,line);
        {writeln('reading line=',line);}
        {pos:=1;
        while line[pos]=' ' do
           pos:=pos+1;}
        {         1234567                 }
        {      1234567890                 }
        {      ___xvxvvvv                 }
        {line:=copy(line,pos,length(line)-pos+1);}
        {writeln('trim line=[',line,']');}
        line:=ltrim(line);
        if not ( (line[1]=';') or (line[1]='[')) then
        begin
            pos:=1;
            haveArg:=False;
            while (line[pos] <> ' ') and (pos <= length(line)) do
            begin
                pos:=pos+1;
                haveArg:=True;
            end;
            if haveArg then
            begin
                key:=copy(line,1,pos-1);
                line4parse:=copy(line,pos+1,length(line)-pos);
                line4parse:=alltrim(line4parse);
            end
            else begin
               key:=line;
               line4parse:='';
            end;
            {writeln('key=[',key,'] line4parse=[',line4parse,']');}
            for i:=1 to count-1 do begin
                {writeln('table[',i,'].itemKeyword=',table[i].itemKeyword);}
                if key=table[i].itemKeyword then
                begin
                    if table[i].itemType=cfgFunc then
                        table[i].itemFunc(line4parse)
                    else if table[i].itemType=cfgText then
                        string(table[i].itemPtr^):=line4parse
                    else if table[i].itemType=cfgLogic then
                        boolean(table[i].itemPtr^):=line4parse='Yes'
                    else if table[i].itemType=cfgInt then
                    begin
                        val(line4parse,int,code);
                        if code=0 then
                            integer(table[i].itemPtr^):=int
                        else
                            integer(table[i].itemPtr^):=0;
                    end;
                end; {if keyword}
            end; {for}
        end; {if not comment}
    end; {while}
    Close(stream);
end;

end.

